/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.spot.ota;

import com.sun.squawk.VM;
import java.io.*;
import javax.microedition.io.*;

/**
 *
 * @author ea149956
 */
public abstract class ServerSocketListener implements Runnable {
    public int port;
    public boolean keepRunning;
    private StreamConnectionNotifier serverConnection = null;

    public ServerSocketListener(int port) {
        this.port = port;
        this.keepRunning = true;
    }

    public abstract Runnable newRunnable(StreamConnection connection);

    public void run() {
        String url = "serversocket://:" + port;
        try {
            serverConnection = (StreamConnectionNotifier) Connector.open(url);
        } catch (IOException e) {
            System.out.println("Failed to establish connection with " + url + ": " + e);
        }
        VM.addShutdownHook(new Thread(new Runnable() {
            public void run() { free(); }
        }));
        VM.println("Opened " + url);
        try {
            while (keepRunning) {
                StreamConnection connection = null;
                try {
                    connection = serverConnection.acceptAndOpen();
                    VM.println("  Received connection on " + url);
                    Runnable runnable = newRunnable(connection);
                    if (runnable == null) {
                        break;
                    }
                    Thread thread = new Thread(runnable, "ServerSocketListener-runnable");
                    thread.start();
                } catch (Throwable t) {
                    if (connection != null) {try {connection.close();} catch (IOException e) {}}
                    t.printStackTrace();
                    try {Thread.sleep(5000);} catch (InterruptedException e){}
                }
            }
        } finally {
            free();
        }
    }

    public void free() {
        if (serverConnection != null) {
            try {serverConnection.close();
                serverConnection = null;
            } catch (IOException e) {}}
    }

    public void start() {
        new Thread(this, this.getClass().getName()).start();
    }

    public void stopRunning() {
        keepRunning = false;
    }

}
