/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.squawk.io.j2me.pipe;

import com.sun.spot.ota.ServerSocketListener;
import com.sun.squawk.Isolate;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import javax.microedition.io.StreamConnection;

/**
 *
 * @author ea149956
 */
public class PipeServerSocketListener extends ServerSocketListener {
    public static final int MAX_QUEUED_SIZE = 8192;
    public static final int DEFAULT_PORT = 8000;

    public static boolean startedPiping;

    protected static PipeServerSocketListener active;

    protected OutputStream[] outputs;
    protected ByteArrayOutputStream queuedOutput;

    public static void startPipingConsoleIfNecessary() {
        if (startedPiping) {
            return;
        }
        // TODO Force a reference to the class as it seems we are running into dead code elimination
        new Protocol();
        Isolate.currentIsolate().addOut("pipe:");
        Isolate.currentIsolate().addErr("pipe:");
        startedPiping = true;
    }

    public static PipeServerSocketListener getActive() {
        return active;
    }
    
    protected static void startIfNecessary() {
        if (active != null) {
            return;
        }
        active = new PipeServerSocketListener(DEFAULT_PORT);
        active.start();
    }

    public PipeServerSocketListener(int port) {
        super(port);
        outputs = new PipeOutputStream[0];
        queuedOutput = new ByteArrayOutputStream();
    }
    
    public Runnable newRunnable(StreamConnection connection) {
        OutputStream[] newOutputs = new OutputStream[outputs.length+1];
        System.arraycopy(outputs, 0, newOutputs, 0, outputs.length);
        OutputStream output = null;
        try {
            output = connection.openOutputStream();
        } catch (IOException e) {
            e.printStackTrace();
        }
        if (outputs.length == 0) {
            try {
                output.write(queuedOutput.toByteArray(), 0, queuedOutput.size());
            } catch (IOException e) {
                e.printStackTrace();
            }
            queuedOutput.reset();
        }
        newOutputs[outputs.length] = output;
        outputs = newOutputs;
        return null;
    }

    public void write(int arg0) throws IOException {
        if (outputs.length == 0) {
            queuedOutput.write(arg0);
            if (queuedOutput.size() > MAX_QUEUED_SIZE) {
                queuedOutput.reset();
            }
            return;
        }
        for (int i=0; i < outputs.length; i++) {
            OutputStream output = outputs[i];
            if (output != null) {
                try {
                    output.write(arg0);
                } catch (IOException e) {
                    outputs[i] = null;
                    e.printStackTrace();
                }
            }
        }
    }

}
