/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.squawk.io.j2me.pipe;

import com.sun.squawk.io.ConnectionBase;
import java.io.*;
import javax.microedition.io.*;

/**
 *
 * @author ea149956
 */
public class Protocol extends ConnectionBase implements StreamConnection {

    /**
     * Open a new "remoteprint" connection to the specified SPOT.
     *<p>
     * Note: the actual "radio" stream connection is opened by RemotePrintOutputStream.
     *
     * @param protocolName = "remoteprint:"
     * @param name the IEEE radio address of the SPOT to connect to and the port to use
     *             for the connection, e.g. "123456:119"
     * @param mode the access mode (ignored)
     * @param timeouts a flag to indicate that the caller wants timeout exceptions (ignored)
     * @return the new remoteprint conection
     *
     * @see com.sun.squawk.io.ConnectionBase#open(java.lang.String, java.lang.String, int, boolean)
     */
    public Connection open(String protocolName, String name, int mode, boolean timeouts) {
        PipeServerSocketListener.startIfNecessary();
        return this;
    }

    /**
     * Close this remoteprint connection.
     * <p>
     * Note: this does not close the radio stream used by the remote printing.
     *
     * @see javax.microedition.io.Connection#close()
     */
    public void close() throws IOException {
        super.close();
    }
    /**
     * Open an InputStream for this connection.
     * <p>
     * Note: remoteprint connections do not support an InputStream.
     *
     * @return null
     *
     * @see com.sun.squawk.io.ConnectionBase#openInputStream()
     */
    public InputStream openInputStream() {
        return null;
    }

    /**
     * Open an OutputStream for this connection.
     * <p>
     * Note: all "remoteprint" connections from this SPOT to the remote print server
     * will share the same OutputStream.
     *
     * @return an OutputStream that goes to the remote print server
     *
     * @see com.sun.squawk.io.ConnectionBase#openOutputStream()
     */
    public OutputStream openOutputStream() {
        return new PipeOutputStream(PipeServerSocketListener.getActive());
    }

}
